Index: squid/src/client_side.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/client_side.c,v
retrieving revision 1.202.2.6
retrieving revision 1.202.2.7
diff -u -r1.202.2.6 -r1.202.2.7
--- squid/src/client_side.c	29 Sep 2007 10:38:27 -0000	1.202.2.6
+++ squid/src/client_side.c	27 Nov 2007 08:12:25 -0000	1.202.2.7
@@ -2242,7 +2283,6 @@
 	     * Query the origin to see what should be done.
 	     */
 	    http->log_type = LOG_TCP_MISS;
-            stmemNodeUnref(&ref);
 	    clientProcessMiss(http);
 	    return;
 	}
@@ -2255,7 +2295,6 @@
 	    debug(33, 4) ("clientCacheHit: Reply code %d != 200\n",
 		mem->reply->sline.status);
 	    http->log_type = LOG_TCP_MISS;
-            stmemNodeUnref(&ref);
 	    clientProcessMiss(http);
 	    return;
 	}
@@ -2290,6 +2329,10 @@
 	debug(33, 2) ("clientProcessHit: refresh_stale HIT\n");
 	http->log_type = LOG_TCP_STALE_HIT;
 	stale = 0;
+    } else if (stale == -2 && e->mem_obj->refresh_timestamp + e->mem_obj->stale_while_revalidate >= squid_curtime) {
+	debug(33, 2) ("clientProcessHit: stale-while-revalidate HIT\n");
+	http->log_type = LOG_TCP_STALE_HIT;
+	stale = 0;
     } else if (stale && http->flags.internal) {
 	debug(33, 2) ("clientProcessHit: internal HIT\n");
 	stale = 0;
@@ -2297,7 +2340,13 @@
 	debug(33, 2) ("clientProcessHit: offline HIT\n");
 	http->log_type = LOG_TCP_OFFLINE_HIT;
 	stale = 0;
+    } else if (stale == -2) {
+	debug(33, 2) ("clientProcessHit: stale-while-revalidate needs revalidation\n");
+	clientAsyncRefresh(http);
+	http->log_type = LOG_TCP_STALE_HIT;
+	stale = 0;
     }
+    http->is_modified = is_modified;
     if (stale) {
 	debug(33, 5) ("clientCacheHit: in refreshCheck() block\n");
 	/*
@@ -2318,12 +2367,20 @@
 	     */
 	    http->log_type = LOG_TCP_CLIENT_REFRESH_MISS;
 	    clientProcessMiss(http);
-	} else {
-	    clientProcessExpired(http);
+	    return;
 	}
-        stmemNodeUnref(&ref);
+	clientRefreshCheck(http);
 	return;
     }
+    clientProcessHit(http);
+}
+
+static void
+clientProcessHit(clientHttpRequest * http)
+{
+    int is_modified = http->is_modified;
+    StoreEntry *e = http->entry;
+
     if (is_modified == 0) {
 	time_t timestamp = e->timestamp;
 	MemBuf mb = httpPacked304Reply(e->mem_obj->reply);
@@ -2343,18 +2400,18 @@
 	storeAppend(e, mb.buf, mb.size);
 	memBufClean(&mb);
 	storeComplete(e);
-        stmemNodeUnref(&ref);
 	return;
     }
     /*
      * plain ol' cache hit
      */
+    if (EBIT_TEST(e->flags, REFRESH_FAILURE))
+	http->log_type = LOG_TCP_NEGATIVE_HIT;
     if (e->store_status != STORE_OK)
 	http->log_type = LOG_TCP_MISS;
     else if (http->log_type == LOG_TCP_HIT && e->mem_status == IN_MEMORY)
 	http->log_type = LOG_TCP_MEM_HIT;
-    clientSendMoreHeaderData(data, stmemNodeRef(&ref), size);
-    stmemNodeUnref(&ref);
+    clientSendHeaders(http, e->mem_obj->reply);
 }
 
 /* put terminating boundary for multiparts */
@@ -2612,49 +2669,32 @@
  * such, writes processed message to the client's socket
  */
 static void
-clientSendMoreHeaderData(void *data, mem_node_ref ref, ssize_t size)
+clientSendHeaders(void *data, HttpReply * rep)
 {
     //const char *buf = ref.node->data + ref.offset;
     clientHttpRequest *http = data;
     StoreEntry *entry = http->entry;
     ConnStateData *conn = http->conn;
     int fd = conn->fd;
-    HttpReply *rep = NULL;
-    debug(33, 5) ("clientSendMoreHeaderData: %s, %d bytes\n", http->uri, (int) size);
-    assert(size <= SM_PAGE_SIZE);
     assert(http->request != NULL);
     dlinkDelete(&http->active, &ClientActiveRequests);
     dlinkAdd(http, &http->active, &ClientActiveRequests);
-    debug(33, 5) ("clientSendMoreHeaderData: FD %d '%s', out.offset=%ld \n",
-	fd, storeUrl(entry), (long int) http->out.offset);
+    debug(33, 5) ("clientSendMoreHeaderData: FD %d '%s'\n", fd, storeUrl(entry));
     assert(conn->reqs.head != NULL);
     if (DLINK_HEAD(conn->reqs) != http) {
 	/* there is another object in progress, defer this one */
 	debug(33, 2) ("clientSendMoreHeaderData: Deferring %s\n", storeUrl(entry));
-        stmemNodeUnref(&ref);
 	return;
     } else if (http->request->flags.reset_tcp) {
 	comm_reset_close(fd);
-        stmemNodeUnref(&ref);
-	return;
-    } else if (entry && EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
-	/* call clientWriteComplete so the client socket gets closed */
-        stmemNodeUnref(&ref);
-	clientWriteComplete(fd, NULL, 0, COMM_OK, http);
-	return;
-    } else if (size < 0) {
-	/* call clientWriteComplete so the client socket gets closed */
-	clientWriteComplete(fd, NULL, 0, COMM_OK, http);
-        stmemNodeUnref(&ref);
 	return;
-    } else if (size == 0) {
+    } else if (!rep) {
 	/* call clientWriteComplete so the client socket gets closed */
 	clientWriteComplete(fd, NULL, 0, COMM_OK, http);
-        stmemNodeUnref(&ref);
 	return;
     }
     assert(http->out.offset == 0);
-    rep = http->reply = clientBuildReply(http);
+    rep = http->reply = clientCloneReply(http, rep);
     if (!rep) {
 	ErrorState *err = errorCon(ERR_INVALID_RESP, HTTP_BAD_GATEWAY, http->orig_request);
 	storeClientUnregister(http->sc, http->entry, http);
@@ -2663,7 +2703,6 @@
 	http->entry = clientCreateStoreEntry(http, http->request->method,
 	    null_request_flags);
 	errorAppendEntry(http->entry, err);
-        stmemNodeUnref(&ref);
 	return;
     }
     clientMaxBodySize(http->request, http, rep);
@@ -2676,7 +2715,6 @@
 	http->entry = clientCreateStoreEntry(http, http->request->method,
 	    null_request_flags);
 	errorAppendEntry(http->entry, err);
-        stmemNodeUnref(&ref);
 	return;
     }
     /* 
@@ -2691,7 +2729,6 @@
      */
     http->range_iter.prefix_size = rep->hdr_sz;
     debug(33, 3) ("clientSendMoreHeaderData: %d bytes of headers\n", rep->hdr_sz);
-    stmemNodeUnref(&ref);
     clientHttpLocationRewriteCheck(http);
 }
 
@@ -2956,7 +2993,7 @@
 	 * If we are here, then store_status == STORE_OK and it
 	 * seems we have a HEAD repsponse which is missing the
 	 * empty end-of-headers line (home.mira.net, phttpd/0.99.72
-	 * does this).  Because clientBuildReply() fails we just
+	 * does this).  Because clientCloneReply() fails we just
 	 * call this reply a body, set the done_copying flag and
 	 * continue...
 	 */
@@ -3047,11 +3084,8 @@
 	if (0 == storeClientCopyPending(http->sc, entry, http)) {
 	    if (EBIT_TEST(entry->flags, ENTRY_ABORTED))
 		debug(33, 0) ("clientKeepaliveNextRequest: ENTRY_ABORTED\n");
-	    storeClientRef(http->sc, entry,
-		http->out.offset,
-		http->out.offset,
-		SM_PAGE_SIZE,
-		clientSendMoreHeaderData,
+	    storeClientCopyHeaders(http->sc, entry,
+		clientSendHeaders,
 		http);
 	}
     }
@@ -3357,10 +3391,7 @@
 #if DELAY_POOLS
 	delaySetStoreClient(http->sc, delayClient(http));
 #endif
-	storeClientRef(http->sc, http->entry,
-	    http->out.offset,
-	    http->out.offset,
-	    SM_PAGE_SIZE,
+	storeClientCopyHeaders(http->sc, http->entry,
 	    clientCacheHit,
 	    http);
     } else {
--- /dev/null	Wed Nov 28 01:20:24 2007
+++ squid/src/client_side_rewrite.c	Wed Nov 28 01:20:25 2007
@@ -0,0 +1,154 @@
+
+/*
+ * $Id: client_side_rewrite.c,v 1.2.4.2 2007/11/27 08:12:27 adri Exp $
+ *
+ * DEBUG: section 33    Client-side Routines - URL Rewriter
+ * AUTHOR: Duane Wessels; Adrian Chadd
+ *
+ * SQUID Web Proxy Cache          http://www.squid-cache.org/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from
+ *  the Internet community; see the CONTRIBUTORS file for full
+ *  details.   Many organizations have provided support for Squid's
+ *  development; see the SPONSORS file for full details.  Squid is
+ *  Copyrighted (C) 2001 by the Regents of the University of
+ *  California; see the COPYRIGHT file for full details.  Squid
+ *  incorporates software developed and/or copyrighted by other
+ *  sources; see the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+#include "squid.h"
+
+
+/* Local functions */
+
+void
+clientRedirectAccessCheckDone(int answer, void *data)
+{
+    clientHttpRequest *http = data;
+    http->acl_checklist = NULL;
+    if (answer == ACCESS_ALLOWED)
+	redirectStart(http, clientRedirectDone, http);
+    else
+	clientRedirectDone(http, NULL);
+}
+
+void
+clientRedirectStart(clientHttpRequest * http)
+{
+    debug(33, 5) ("clientRedirectStart: '%s'\n", http->uri);
+    if (Config.Program.url_rewrite.command == NULL) {
+	clientRedirectDone(http, NULL);
+	return;
+    }
+    if (Config.accessList.url_rewrite) {
+	http->acl_checklist = clientAclChecklistCreate(Config.accessList.url_rewrite, http);
+	aclNBCheck(http->acl_checklist, clientRedirectAccessCheckDone, http);
+    } else {
+	redirectStart(http, clientRedirectDone, http);
+    }
+}
+
+void
+clientRedirectDone(void *data, char *result)
+{
+    clientHttpRequest *http = data;
+    request_t *new_request = NULL;
+    request_t *old_request = http->request;
+    const char *urlgroup = http->conn->port->urlgroup;
+    debug(33, 5) ("clientRedirectDone: '%s' result=%s\n", http->uri,
+	result ? result : "NULL");
+    assert(http->redirect_state == REDIRECT_PENDING);
+    http->redirect_state = REDIRECT_DONE;
+    if (result) {
+	http_status status;
+	if (*result == '!') {
+	    char *t;
+	    if ((t = strchr(result + 1, '!')) != NULL) {
+		urlgroup = result + 1;
+		*t++ = '\0';
+		result = t;
+	    } else {
+		debug(33, 1) ("clientRedirectDone: bad input: %s\n", result);
+	    }
+	}
+	status = (http_status) atoi(result);
+	if (status == HTTP_MOVED_PERMANENTLY
+	    || status == HTTP_MOVED_TEMPORARILY
+	    || status == HTTP_SEE_OTHER
+	    || status == HTTP_TEMPORARY_REDIRECT) {
+	    char *t = result;
+	    if ((t = strchr(result, ':')) != NULL) {
+		http->redirect.status = status;
+		http->redirect.location = xstrdup(t + 1);
+		goto redirect_parsed;
+	    } else {
+		debug(33, 1) ("clientRedirectDone: bad input: %s\n", result);
+	    }
+	} else if (strcmp(result, http->uri))
+	    new_request = urlParse(old_request->method, result);
+    }
+  redirect_parsed:
+    if (new_request) {
+	safe_free(http->uri);
+	http->uri = xstrdup(urlCanonical(new_request));
+	new_request->http_ver = old_request->http_ver;
+	httpHeaderAppend(&new_request->header, &old_request->header);
+	new_request->client_addr = old_request->client_addr;
+	new_request->client_port = old_request->client_port;
+#if FOLLOW_X_FORWARDED_FOR
+	new_request->indirect_client_addr = old_request->indirect_client_addr;
+#endif /* FOLLOW_X_FORWARDED_FOR */
+	new_request->my_addr = old_request->my_addr;
+	new_request->my_port = old_request->my_port;
+	new_request->flags = old_request->flags;
+	new_request->flags.redirected = 1;
+	if (old_request->auth_user_request) {
+	    new_request->auth_user_request = old_request->auth_user_request;
+	    authenticateAuthUserRequestLock(new_request->auth_user_request);
+	}
+	if (old_request->body_reader) {
+	    new_request->body_reader = old_request->body_reader;
+	    new_request->body_reader_data = old_request->body_reader_data;
+	    old_request->body_reader = NULL;
+	    old_request->body_reader_data = NULL;
+	}
+	new_request->content_length = old_request->content_length;
+	if (strBuf(old_request->extacl_log))
+	    new_request->extacl_log = stringDup(&old_request->extacl_log);
+	if (old_request->extacl_user)
+	    new_request->extacl_user = xstrdup(old_request->extacl_user);
+	if (old_request->extacl_passwd)
+	    new_request->extacl_passwd = xstrdup(old_request->extacl_passwd);
+	requestUnlink(old_request);
+	http->request = requestLink(new_request);
+    } else {
+	/* Don't mess with urlgroup on internal request */
+	if (old_request->flags.internal)
+	    urlgroup = NULL;
+    }
+    safe_free(http->request->urlgroup);		/* only paranoia. should not happen */
+    if (urlgroup && *urlgroup)
+	http->request->urlgroup = xstrdup(urlgroup);
+    clientInterpretRequestHeaders(http);
+    /* XXX This really should become a ref-counted string type pointer, not a copy! */
+    fd_note(http->conn->fd, http->uri);
+
+    clientStoreURLRewriteStart(http);
+}
--- /dev/null	Wed Nov 28 01:20:24 2007
+++ squid/src/client_side_storeurl_rewrite.c	Wed Nov 28 01:20:25 2007
@@ -0,0 +1,92 @@
+
+/*
+ * $Id: client_side_storeurl_rewrite.c,v 1.3.2.2 2007/11/27 08:12:27 adri Exp $
+ *
+ * DEBUG: section 85    Client-side Routines - Store URL Rewriter
+ * AUTHOR: Duane Wessels; Adrian Chadd
+ *
+ * SQUID Web Proxy Cache          http://www.squid-cache.org/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from
+ *  the Internet community; see the CONTRIBUTORS file for full
+ *  details.   Many organizations have provided support for Squid's
+ *  development; see the SPONSORS file for full details.  Squid is
+ *  Copyrighted (C) 2001 by the Regents of the University of
+ *  California; see the COPYRIGHT file for full details.  Squid
+ *  incorporates software developed and/or copyrighted by other
+ *  sources; see the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+#include "squid.h"
+
+
+/* Local functions */
+
+void
+clientStoreURLRewriteAccessCheckDone(int answer, void *data)
+{
+    clientHttpRequest *http = data;
+    http->acl_checklist = NULL;
+    if (answer == ACCESS_ALLOWED)
+	storeurlStart(http, clientStoreURLRewriteDone, http);
+    else
+	clientStoreURLRewriteDone(http, NULL);
+}
+
+void
+clientStoreURLRewriteStart(clientHttpRequest * http)
+{
+    debug(85, 5) ("clientStoreURLRewriteStart: '%s'\n", http->uri);
+    if (Config.Program.store_rewrite.command == NULL) {
+	clientStoreURLRewriteDone(http, NULL);
+	return;
+    }
+    if (Config.accessList.storeurl_rewrite) {
+	http->acl_checklist = clientAclChecklistCreate(Config.accessList.storeurl_rewrite, http);
+	aclNBCheck(http->acl_checklist, clientStoreURLRewriteAccessCheckDone, http);
+    } else {
+	storeurlStart(http, clientStoreURLRewriteDone, http);
+    }
+}
+
+void
+clientStoreURLRewriteDone(void *data, char *result)
+{
+    clientHttpRequest *http = data;
+
+    debug(85, 3) ("clientStoreURLRewriteDone: '%s' result=%s\n", http->uri,
+	result ? result : "NULL");
+#if 0
+    assert(http->redirect_state == REDIRECT_PENDING);
+    http->redirect_state = REDIRECT_DONE;
+#endif
+
+    if (result) {
+	http->request->store_url = xstrdup(result);
+	debug(85, 3) ("Rewrote to %s\n", http->request->store_url);
+	/* XXX is this actually the right spot to do this? How about revalidation? */
+	//storeEntrySetStoreUrl(http->entry, result);
+    }
+    /* This is the final part of the rewrite chain - this should be broken out! */
+    clientInterpretRequestHeaders(http);
+#if HEADERS_LOG
+    headersLog(0, 1, request->method, request);
+#endif
+    clientAccessCheck2(http);
+}
Index: squid/src/enums.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/enums.h,v
retrieving revision 1.62
retrieving revision 1.62.2.1
diff -u -r1.62 -r1.62.2.1
--- squid/src/enums.h	24 Sep 2007 13:52:08 -0000	1.62
+++ squid/src/enums.h	27 Nov 2007 08:12:27 -0000	1.62.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: enums.h,v 1.62 2007/09/24 13:52:08 squidadm Exp $
+ * $Id: enums.h,v 1.62.2.1 2007/11/27 08:12:27 adri Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -52,6 +52,8 @@
     LOG_TCP_REDIRECT,
 #endif
     LOG_TCP_STALE_HIT,
+    LOG_TCP_ASYNC_HIT,
+    LOG_TCP_ASYNC_MISS,
     LOG_UDP_HIT,
     LOG_UDP_MISS,
     LOG_UDP_DENIED,
@@ -525,7 +527,7 @@
     ENTRY_REVALIDATE,
     DELAY_SENDING,
     RELEASE_REQUEST,
-    REFRESH_REQUEST,
+    REFRESH_FAILURE,
     ENTRY_CACHABLE,
     ENTRY_DISPATCHED,
     KEY_PRIVATE,
@@ -654,6 +656,7 @@
     STORE_META_VARY_HEADERS,	/* Stores Vary request headers */
     STORE_META_STD_LFS,		/* standard metadata in lfs format */
     STORE_META_OBJSIZE,		/* object size, if its known */
+    STORE_META_STOREURL,	/* the store url, if different to the normal URL */
     STORE_META_END
 };
 
Index: squid/src/errorpage.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/errorpage.c,v
retrieving revision 1.37
retrieving revision 1.37.6.1
diff -u -r1.37 -r1.37.6.1
--- squid/src/errorpage.c	26 Feb 2007 09:51:31 -0000	1.37
+++ squid/src/errorpage.c	27 Nov 2007 08:12:27 -0000	1.37.6.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: errorpage.c,v 1.37 2007/02/26 09:51:31 squidadm Exp $
+ * $Id: errorpage.c,v 1.37.6.1 2007/11/27 08:12:27 adri Exp $
  *
  * DEBUG: section 4     Error Generation
  * AUTHOR: Duane Wessels
@@ -324,7 +324,7 @@
     authenticateFixHeader(rep, err->auth_user_request, err->request, 0, 1);
     httpReplySwapOut(rep, entry);
     EBIT_CLR(entry->flags, ENTRY_FWD_HDR_WAIT);
-    storeNegativeCache(entry);
+    storeExpireNow(entry);
     storeReleaseRequest(entry);
     storeBufferFlush(entry);
     storeComplete(entry);
Index: squid/src/fqdncache.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fqdncache.c,v
retrieving revision 1.22
retrieving revision 1.22.2.1
diff -u -r1.22 -r1.22.2.1
--- squid/src/fqdncache.c	17 Sep 2007 09:51:44 -0000	1.22
+++ squid/src/fqdncache.c	27 Nov 2007 08:12:27 -0000	1.22.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: fqdncache.c,v 1.22 2007/09/17 09:51:44 squidadm Exp $
+ * $Id: fqdncache.c,v 1.22.2.1 2007/11/27 08:12:27 adri Exp $
  *
  * DEBUG: section 35    FQDN Cache
  * AUTHOR: Harvest Derived
@@ -316,7 +316,7 @@
 	f->error_message = xstrdup("No PTR record");
 	return f;
     }
-    if (ttl == 0 || ttl > Config.positiveDnsTtl)
+    if (ttl > Config.positiveDnsTtl)
 	ttl = Config.positiveDnsTtl;
     if (ttl < Config.negativeDnsTtl)
 	ttl = Config.negativeDnsTtl;
Index: squid/src/helper.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/helper.c,v
retrieving revision 1.43
retrieving revision 1.43.6.1
diff -u -r1.43 -r1.43.6.1
--- squid/src/helper.c	1 Apr 2007 15:08:17 -0000	1.43
+++ squid/src/helper.c	27 Nov 2007 08:12:27 -0000	1.43.6.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: helper.c,v 1.43 2007/04/01 15:08:17 squidadm Exp $
+ * $Id: helper.c,v 1.43.6.1 2007/11/27 08:12:27 adri Exp $
  *
  * DEBUG: section 84    Helper process maintenance
  * AUTHOR: Harvest Derived?
@@ -1026,7 +1026,7 @@
 {
     helper *hlp = srv->parent;
     helper_request **ptr = NULL;
-    int slot;
+    int slot = -1;
     if (!cbdataValid(r->data)) {
 	debug(84, 1) ("helperDispatch: invalid callback data\n");
 	helperRequestFree(r);
@@ -1057,8 +1057,8 @@
 	    helperDispatch_done,	/* Handler */
 	    srv);
     }
-    debug(84, 5) ("helperDispatch: Request sent to %s #%d, %d bytes\n",
-	hlp->id_name, srv->index + 1, (int) strlen(r->buf));
+    debug(84, 5) ("helperDispatch: Request sent to %s #%d[%d], %d bytes\n",
+	hlp->id_name, srv->index + 1, slot, (int) strlen(r->buf));
     srv->stats.uses++;
     hlp->stats.requests++;
 }
Index: squid/src/http.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/http.c,v
retrieving revision 1.63
retrieving revision 1.63.2.1
diff -u -r1.63 -r1.63.2.1
--- squid/src/http.c	3 Sep 2007 04:49:47 -0000	1.63
+++ squid/src/http.c	27 Nov 2007 08:12:28 -0000	1.63.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: http.c,v 1.63 2007/09/03 04:49:47 squidadm Exp $
+ * $Id: http.c,v 1.63.2.1 2007/11/27 08:12:28 adri Exp $
  *
  * DEBUG: section 11    Hypertext Transfer Protocol (HTTP)
  * AUTHOR: Harvest Derived
@@ -131,6 +131,8 @@
     storeNegativeCache(entry);
     if (EBIT_TEST(entry->flags, ENTRY_CACHABLE))
 	storeSetPublicKey(entry);
+    if (entry->expires <= squid_curtime)
+	storeRelease(entry);
 }
 
 static void
@@ -432,7 +434,7 @@
 	debug(11, 3) ("httpProcessReplyHeader: Non-HTTP-compliant header: '%s'\n", httpState->reply_hdr.buf);
 	httpState->reply_hdr_state += 2;
 	httpState->chunk_size = -1;	/* Terminated by EOF */
-	memBufClean(&httpState->reply_hdr);
+	httpState->reply_hdr.size = old_size;
 	httpBuildVersion(&reply->sline.version, 0, 9);
 	reply->sline.status = HTTP_INVALID_HEADER;
 	ctx_exit(ctx);
@@ -506,8 +508,8 @@
 	stringClean(&tr);
 	if (httpState->flags.chunked && reply->content_length >= 0) {
 	    /* Can't have a content-length in chunked encoding */
-	    reply->sline.status = HTTP_INVALID_HEADER;
-	    return done;
+	    reply->content_length = -1;
+	    httpHeaderDelById(&reply->header, HDR_CONTENT_LENGTH);
 	}
     }
     if (!httpState->flags.chunked) {
@@ -530,6 +532,8 @@
 	if (strBuf(httpState->orig_request->vary_encoding))
 	    entry->mem_obj->vary_encoding = xstrdup(strBuf(httpState->orig_request->vary_encoding));
     }
+    if (entry->mem_obj->old_entry)
+	EBIT_CLR(entry->mem_obj->old_entry->flags, REFRESH_FAILURE);
     switch (httpCachableReply(httpState)) {
     case 1:
 	httpMakePublic(entry);
@@ -538,10 +542,7 @@
 	httpMakePrivate(entry);
 	break;
     case -1:
-	if (Config.negativeTtl > 0)
-	    httpCacheNegatively(entry);
-	else
-	    httpMakePrivate(entry);
+	httpCacheNegatively(entry);
 	break;
     default:
 	assert(0);
@@ -955,6 +956,8 @@
 		    httpHeaderPutTime(&reply->header, HDR_DATE, squid_curtime);
 		    mb = httpReplyPack(reply);
 		    storeAppend(entry, mb.buf, mb.size);
+		    storeAppend(entry, httpState->reply_hdr.buf, httpState->reply_hdr.size);
+		    memBufClean(&httpState->reply_hdr);
 		    httpReplyReset(reply);
 		    httpReplyParse(reply, mb.buf, mb.size);
 		    memBufClean(&mb);
@@ -1145,13 +1148,14 @@
 	    /* append unless we added our own;
 	     * note: at most one client's ims header can pass through */
 	    if (!httpHeaderHas(hdr_out, HDR_IF_MODIFIED_SINCE))
-		httpHeaderAddClone(hdr_out, e);
+		if (!Config.onoff.ignore_ims_on_miss || !orig_request->flags.cachable || orig_request->flags.auth)
+		    httpHeaderAddClone(hdr_out, e);
 	    break;
 	case HDR_IF_NONE_MATCH:
-	    /* append unless we added our own;
-	     * note: at most one client's ims header can pass through */
+	    /* append unless ignore_ims_on_miss is in effect */
 	    if (!httpHeaderHas(hdr_out, HDR_IF_NONE_MATCH))
-		httpHeaderAddClone(hdr_out, e);
+		if (!Config.onoff.ignore_ims_on_miss || !orig_request->flags.cachable || orig_request->flags.auth)
+		    httpHeaderAddClone(hdr_out, e);
 	    break;
 	case HDR_MAX_FORWARDS:
 	    if (orig_request->method == METHOD_TRACE) {
@@ -1253,10 +1257,10 @@
 	    /* Special mode, to pass the username to the upstream cache */
 	    char loginbuf[256];
 	    const char *username = "-";
-	    if (orig_request->auth_user_request)
-		username = authenticateUserRequestUsername(orig_request->auth_user_request);
-	    else if (orig_request->extacl_user)
+	    if (orig_request->extacl_user)
 		username = orig_request->extacl_user;
+	    else if (orig_request->auth_user_request)
+		username = authenticateUserRequestUsername(orig_request->auth_user_request);
 	    snprintf(loginbuf, sizeof(loginbuf), "%s%s", username, orig_request->peer_login + 1);
 	    httpHeaderPutStrf(hdr_out, HDR_PROXY_AUTHORIZATION, "Basic %s",
 		base64_encode(loginbuf));
Index: squid/src/ipcache.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ipcache.c,v
retrieving revision 1.25
retrieving revision 1.25.2.1
diff -u -r1.25 -r1.25.2.1
--- squid/src/ipcache.c	17 Sep 2007 09:51:44 -0000	1.25
+++ squid/src/ipcache.c	27 Nov 2007 08:12:28 -0000	1.25.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ipcache.c,v 1.25 2007/09/17 09:51:44 squidadm Exp $
+ * $Id: ipcache.c,v 1.25.2.1 2007/11/27 08:12:28 adri Exp $
  *
  * DEBUG: section 14    IP Cache
  * AUTHOR: Harvest Derived
@@ -369,7 +369,7 @@
 	i->addrs.count = (unsigned char) na;
     else
 	i->addrs.count = 255;
-    if (ttl == 0 || ttl > Config.positiveDnsTtl)
+    if (ttl > Config.positiveDnsTtl)
 	ttl = Config.positiveDnsTtl;
     if (ttl < Config.negativeDnsTtl)
 	ttl = Config.negativeDnsTtl;
Index: squid/src/main.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/main.c,v
retrieving revision 1.80
retrieving revision 1.80.2.1
diff -u -r1.80 -r1.80.2.1
--- squid/src/main.c	24 Sep 2007 13:52:09 -0000	1.80
+++ squid/src/main.c	27 Nov 2007 08:12:28 -0000	1.80.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: main.c,v 1.80 2007/09/24 13:52:09 squidadm Exp $
+ * $Id: main.c,v 1.80.2.1 2007/11/27 08:12:28 adri Exp $
  *
  * DEBUG: section 1     Startup and Main Loop
  * AUTHOR: Harvest Derived
@@ -396,9 +396,11 @@
     idnsShutdown();
 #endif
     redirectShutdown();
+    storeurlShutdown();
     locationRewriteShutdown();
     authenticateShutdown();
     externalAclShutdown();
+    refreshCheckShutdown();
     storeDirCloseSwapLogs();
     storeLogClose();
     accessLogClose();
@@ -425,9 +427,11 @@
     idnsInit();
 #endif
     redirectInit();
+    storeurlInit();
     locationRewriteInit();
     authenticateInit(&Config.authConfig);
     externalAclInit();
+    refreshCheckInit();
 #if USE_WCCP
     wccpInit();
 #endif
@@ -463,6 +467,7 @@
     locationRewriteShutdown();
     authenticateShutdown();
     externalAclShutdown();
+    refreshCheckShutdown();
     _db_rotate_log();		/* cache.log */
     storeDirWriteCleanLogs(1);
     storeDirSync();		/* Flush pending I/O ops */
@@ -478,9 +483,11 @@
     dnsInit();
 #endif
     redirectInit();
+    storeurlInit();
     locationRewriteInit();
     authenticateInit(&Config.authConfig);
     externalAclInit();
+    refreshCheckInit();
 }
 
 static void
@@ -576,10 +583,12 @@
     idnsInit();
 #endif
     redirectInit();
+    storeurlInit();
     locationRewriteInit();
     errorMapInit();
     authenticateInit(&Config.authConfig);
     externalAclInit();
+    refreshCheckInit();
     useragentOpenLog();
     refererOpenLog();
     httpHeaderInitModule();	/* must go before any header processing (e.g. the one in errorInitialize) */
@@ -715,7 +724,9 @@
 #endif
     mainParseOptions(argc, argv);
 
+#if HAVE_SYSLOG && defined(LOG_LOCAL4)
     openlog(appname, LOG_PID | LOG_NDELAY | LOG_CONS, syslog_facility);
+#endif
 
 #if defined(USE_WIN32_SERVICE) && defined(_SQUID_WIN32_)
     if (opt_install_service) {
@@ -1087,6 +1098,7 @@
 #endif
     redirectShutdown();
     externalAclShutdown();
+    refreshCheckShutdown();
     locationRewriteShutdown();
     icpConnectionClose();
 #if USE_HTCP
